#!/bin/csh

if (  $#argv != 2) then
   echo '    '
   echo 'Syntax:  make_gnuplot_latex.sh  <in_file>   <out_file> '
   echo 'Example:  make_gnuplot_latex.sh  1 fig.pdf'
else

echo " "
echo " "
echo " "
echo $argv[1]  $argv[2]
echo " "
echo " "

  set file=$argv[1]
  set fig=$argv[2]

  epstopdf $file.eps

  
cat << EOF > tiskA.tex
\documentclass{article}
\usepackage{graphics}
\usepackage{nopageno}
\usepackage{txfonts}
\usepackage{amssymb}
\usepackage{mathrsfs}
%\usepackage{amsmath}
\usepackage[usenames]{color}
%\setlength{\pagewidth}{4.7in}
%\setlength{\pageheight}{3.4in}
%\hoffset -2.1in
%\voffset -3.8in

\input{def.tex}

\begin{document}
\begin{center}
\input{$file.tex}
\end{center}
\end{document}
EOF

pdflatex tiskA.tex 
pdfcrop tiskA.pdf 

mv tiskA-crop.pdf $fig

#rm -f tiskA.tex tiskA.pdf $file.pdf smaz

endif
